$! Compile and link Mosaic 2.6 with MMS or MMK.
$! The command procedure determines /MACRO arguments.  Debugging is invoked
$! if P1 is set to DEBUG.  Other MMS parameters can be added in P2, e.g.
$! /IGNORE=WARNING to make MMS ignore compilation warnings.  Additional
$! /MACRO arguments, e.g. NOWAIS=1 to exclude direct WAIS support,
$! can be added in P3.
$! Bjrn S. Nilsson, 30-Dec-1994
$! Mosaic 2.6, George Cook, 1-Nov-1995
$!
$ Verif = F$Verify(0)
$ On Error Then GoTo End
$ On Control_Y Then GoTo EndY
$ Macro = "("
$ Command = "MMS"
$ If F$Search("SYS$System:MMS.Exe") .EQS. ""
$  Then If F$Search("MMK_DIR:MMK.Exe") .NES. ""
$   Then 
$    Macro = Macro + "USE_MMK=1,"
$    Command = "MMK"
$   Else
$    Write SYS$Output "Neither MMS or MMK appears to be available!"
$    GoTo Err
$   EndIf
$  EndIf
$ Extras = P2
$ If F$GetJPI("","CLINAME") .EQS. "DCL_RECALL" Then Extras = Extras + "/CLI=DCL"
$ If P3 .NES. "" Then Macro = "(" + P3 +","
$ If F$Locate("DEBUG",P1) .NE. F$Length(P1) Then Macro = Macro + "DEBUG=1,"
$ Platform = F$GetSYI("Arch_Name")
$ If Platform .EQS. "Alpha" Then Macro = Macro + "AXP=1,ALPHA=1,"
$ If F$Search("SYS$System:DECC$Compiler.Exe") .NES. "" Then -
   Macro = Macro + "DECC=1,"
$ If F$Trnlnm("MULTINET") .NES. "" Then Macro = Macro + "MULTINET=1,"
$ If F$Trnlnm("TWG$TCP") .NES. "" Then Macro = Macro + "PATHWAY=1,"
$ If F$Search("SYS$Update:DECW$Get_Image_Version.COM") .NES. ""
$  Then
$   @SYS$Update:DECW$Get_Image_Version SYS$Share:DECW$XLibshr.EXE DECW$Version 
$! Motif12 ?
$   If (F$Length(DECW$Version) .NE. 0) .AND. -
     (F$Locate("V1.2", DECW$Version) .NE. F$Length(DECW$Version)) Then -
       Macro = Macro + "MOTIF1_2=1,"
$  Else
$   Write SYS$Output "You do not seem to have DECW Motif installed correctly!"
$   GoTo Err
$  EndIf
$ If F$Trnlnm("XMU") .EQS. ""
$  Then
$   Write SYS$Output -
"You can not build Mosaic without the XMU auxilliary library. It comes as an"
"optional subset with DECWindows Motif, so you should install that now."
$   GoTo Err
$  EndIf
$!
$! Checking done
$!
$ Quals = Extras
$ If Macro .NES. "("
$  Then
$   Quals = Quals + "/Macro=" + Macro + ")"
$   Quals = Quals - ",)"
$   Quals = Quals + ")"
$  EndIf
$!
$! Run MMS or MMK now
$!
$ Write SYS$Output "''Command' will be invoked as ''Command'''Quals'"
$ If Command .EQS. "MMS"
$  Then MMS'Quals'
$  Else MMK'Quals'
$  EndIF
$End:
$ xxx = F$Verify(Verif)
$ Exit
$Err:
$ xxx = F$Verify(Verif)
$ Exit 18
$EndY:
$ Write SYS$Output "Execution interrupted..."
$ xxx = F$Verify(Verif)
$ Exit
