#include <stdio.h>
#ifndef MULTINET
#include <sys/types.h>
#if defined(VMS) && defined(CADDR_T)
#define __CADDR_T
#endif /* VMS, include file problem, BSN */
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <sys/time.h>
#if defined(VMS) && !defined(WIN_TCP)
#include <ucx$inetdef.h>
#include <tcp.h>
#else
#include <sys/ioctl.h>
#endif /* VMS, use ioctl stuff in [.libwww2]httcp.c for UCX, GEC */
#else
#if defined(__TIME_T) && !defined(__TYPES_LOADED) && !defined(__TYPES)
#define __TYPES_LOADED
#endif /* Different defs in OpenVMS and MultiNet include files, BSN */
#include "multinet_root:[multinet.include.sys]types.h"
#include "multinet_root:[multinet.include.sys]socket.h"
#include "multinet_root:[multinet.include.netinet]in.h"
#include "multinet_root:[multinet.include]netdb.h"
#include "multinet_root:[multinet.include.sys]time.h"
#include "multinet_root:[multinet.include.sys]ioctl.h"
#endif /* MULTINET, BSN, GEC */

/*For memset*/
#ifndef VMS
#include <memory.h>
#else
#include <string.h>
#endif /* VMS, GEC */

#ifdef MOTOROLA
#include <sys/filio.h>
#endif

#ifdef SOLARIS
#include <sys/filio.h>
#endif  

#include "port.h"
#include "accept.h"

#include "memStuffForPipSqueeks.h"

ListenAddress NetServerInitSocket(portNumber)
/* return -1 on error */
int portNumber;
{
ListenAddress socketFD;
struct sockaddr_in serverAddress;
struct protoent *protocolEntry;

	protocolEntry = getprotobyname("tcp");
	if (protocolEntry) {
		socketFD = socket(AF_INET, SOCK_STREAM,protocolEntry->p_proto);
		}
	else {
		socketFD = socket(AF_INET, SOCK_STREAM,0);
		}
	
	if (socketFD < 0) {

#ifdef DEBUG
		fprintf(stderr,"Can't create socket\n");
#endif
		return(-1);
		}

/*        bzero((char *) &serverAddress, sizeof(serverAddress));*/
	memset((char *) &serverAddress, 0, sizeof(serverAddress));
	serverAddress.sin_family = AF_INET;
	serverAddress.sin_addr.s_addr = htonl(INADDR_ANY);
	serverAddress.sin_port = htons(portNumber);

	if (bind(socketFD, (struct sockaddr *) &serverAddress, 
		sizeof(serverAddress))<0){
#ifdef DEBUG
		fprintf(stderr,"Can't bind to address\n");
#endif
		return(-1);
		}


	if (listen(socketFD,5) == -1) {
#ifdef DEBUG
		fprintf(stderr,"Can't listen\n");
#endif
		return(-1);
		}

	/* set socket to non-blocking */
#ifndef MULTINET
	ioctl(socketFD,FIONBIO,0);
#else
	socket_ioctl(socketFD,FIONBIO,0);
#endif /* MULTINET, GEC */

	return(socketFD);
}


PortDescriptor *NetServerAccept(socketFD)
/* accept a connection off of a base socket */
/* do not block! */
/* return NULL if no connection else return PortDescriptor*  */
ListenAddress socketFD;
{
int newSocketFD;
struct sockaddr_in clientAddress;
int clientAddressLength;
PortDescriptor *c;



	/* it's assumed that the socketFD has already been set to non block*/
	clientAddressLength = sizeof(clientAddress);
	newSocketFD = accept(socketFD,(struct sockaddr *) &clientAddress,
				&clientAddressLength);
	if (newSocketFD < 0) {
		return(NULL);
		}

	/* we have connection */
	if (!(c =(PortDescriptor *)MALLOC(sizeof(PortDescriptor)))){
		return(0);
		}
	c->socketFD = newSocketFD;
	c->numInBuffer = 0;

	return(c);
}


int NetRead(c,buffer,bufferSize)
/* read input from port, return number of bytes read */

PortDescriptor *c;
char *buffer;
int bufferSize;
{
int length;

#ifndef MULTINET
	length = read(c->socketFD, buffer, bufferSize);
#else
	length = socket_read(c->socketFD, buffer, bufferSize);
#endif /* MULTINET, GEC */
	return(length);

}



int NetServerWrite(c,buffer,bufferSize)
/* send buffer, return number of bytes sent */
PortDescriptor *c;
char *buffer;
int bufferSize;
{
int length;

#ifndef MULTINET
	length = write(c->socketFD,buffer,bufferSize);
#else
	length = socket_write(c->socketFD,buffer,bufferSize);
#endif /* MULTINET, GEC */

	return(length);
}


int NetCloseConnection(c)
/* close the connection */
PortDescriptor *c;
{
#ifndef MULTINET
	close(c->socketFD);
#else
	socket_close(c->socketFD);
#endif /* MULTINET, GEC */
}

int NetCloseAcceptPort(s)
int s;
{
#ifndef MULTINET
	close(s);
#else
	socket_close(s);
#endif /* MULTINET, GEC */
}



int NetIsThereInput(p)
/* Do a non block check on socket for input and return 1 for yes, 0 for no */
PortDescriptor *p;
{
static struct  timeval timeout = { 0L , 0L };
/*int val;*/
fd_set readfds;


	FD_ZERO(&readfds);
	FD_SET(p->socketFD,&readfds);
	if (0 < select(32, &readfds, 0, 0, &timeout)){
		return(1);
		}
	else {
		return(0);
		}
	
}

int NetIsThereAConnection(socketFD)
/* Do a non block check on socket for input and return 1 for yes, 0 for no */
int socketFD;
{
static struct  timeval timeout = { 0L , 0L };
/*int val;*/
fd_set readfds;


	FD_ZERO(&readfds);
	FD_SET(socketFD,&readfds);
	if (0 < select(32, &readfds, 0, 0, &timeout)){
		return(1);
		}
	else {
		return(0);
		}
}
int NetGetSocketDescriptor(s)
/* extract socket file descriptor from the Port structure */
PortDescriptor *s;
{
        return(s->socketFD);
}

